﻿using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Windows;
using WpfApp1.Annotations;

namespace WpfApp1
{
    public partial class MainWindow
    {
        public MainWindow()
        {
            InitializeComponent();
            Treemap.ItemsSource = GenerateData();
        }


        private List<Level1> GenerateData()
        {
            var list31 = new List<Level3>
            {
                new Level3 { Label = "Level3Node1", Value = 1 },
                new Level3 { Label = "Level3Node2", Value = 1 }
            };

            var list32 = new List<Level3>
            {
                new Level3 { Label = "Level3Node3", Value = 1 },
                new Level3 { Label = "Level3Node4", Value = 1 }
            };

            var list33 = new List<Level3>
            {
                new Level3 { Label = "Level3Node5", Value = 1 },
                new Level3 { Label = "Level3Node6", Value = 1 }
            };

            var list34 = new List<Level3>
            {
                new Level3 { Label = "Level3Node7", Value = 1 },
                new Level3 { Label = "Level3Node8", Value = 1 }
            };

            var list21 = new List<Level2>
            {
                new Level2 { Label = "Level2Node1", Value = 1, Childs = list31 },
                new Level2 { Label = "Level2Node2", Value = 1, Childs = list32 }
            };

            var list22 = new List<Level2>
            {
                new Level2 { Label = "Level2Node3", Value = 1, Childs = list33 },
                new Level2 { Label = "Level2Node4", Value = 1, Childs = list34 }
            };

            var list = new List<Level1>
            {
                new Level1 { Label = "Level1Node1", Value = 1, Childs = list21 },
                new Level1 { Label = "Level1Node2", Value = 1, Childs = list22 }
            };

            return list;
        }

        private void ChangeLabelOnClick(object sender, RoutedEventArgs e)
        {
            foreach (var child1 in Treemap.ItemsSource.OfType<Level1>())
            {
                child1.Label = "New " + child1.Label;
                foreach (var child2 in child1.Childs)
                {
                    child2.Label = "New " + child2.Label;
                    foreach (var child3 in child2.Childs)
                    {
                        child3.Label = "New " + child3.Label;
                    }
                }
            }
        }
    }

    public class Level1 : INotifyPropertyChanged
    {
        private string _label;

        public string Label
        {
            get => _label;
            set
            {
                _label = value;
                OnPropertyChanged();
            }
        }

        public int Value { get; set; }
        public List<Level2> Childs { get; set; }
        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }

    public class Level2 : INotifyPropertyChanged
    {
        private string _label;

        public string Label
        {
            get => _label;
            set
            {
                _label = value;
                OnPropertyChanged();
            }
        }

        public int Value { get; set; }
        public List<Level3> Childs { get; set; }

        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }

    public class Level3 : INotifyPropertyChanged
    {
        private string _label;

        public string Label
        {
            get => _label;
            set
            {
                _label = value;
                OnPropertyChanged();
            }
        }

        public int Value { get; set; }

        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}